Ruby - Bug #14612

IPv6 address inconsistency (downcase vs. upcase)
03/17/2018 11:52 PM - chucke (Tiago Cardoso)

Status: Closed
Priority: Normal
Assignee: akr (Akira Tanaka)

Target version:

ruby -v: 25.0 Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:
UNKNOWN

Description

I've noticed that sometimes ip addresses re shown using a-f characters in downcase, other times upcase. Here is a small script to
show results:

require "resolv"

require "socket"

puts TCPSocket.getaddress ("nghttp2.o0rg") #=> "2400:8902::f03c:91ff:fe69:a454"

puts Resolv.getaddresses ("nghttp2.org") #=> ["139.162.123.134", "2400:8902::F03C:91FF:FE69:A454"]
Results might be system-dependent (I'm using Mac OS High Sierra).

This makes compare operations a bit harder.

Associated revisions

Revision 1da3a31a510211db121e0df4ca456838a437537f - 07/30/2019 02:59 AM - akr (Akira Tanaka)

Use lowercase letters for IPv6 addresses.

Reported by chucke (Tiago Cardoso).
Patch by jeremyevans0 (Jeremy Evans).
[Bug #14612]

Revision 1da3a31a5f0211db121e0df4ca456838a437537f - 07/30/2019 02:59 AM - akr (Akira Tanaka)

Use lowercase letters for IPv6 addresses.

Reported by chucke (Tiago Cardoso).
Patch by jeremyevans0 (Jeremy Evans).
[Bug #14612]

Revision 1da3a31a - 07/30/2019 02:59 AM - akr (Akira Tanaka)
Use lowercase letters for IPv6 addresses.
Reported by chucke (Tiago Cardoso).

Patch by jeremyevans0 (Jeremy Evans).
[Bug #14612]

History

#1 - 03/18/2018 01:35 AM - shevegen (Robert A. Heiler)

Is there a standard that mandates or prefers either variant?

If not then perhaps ruby should decide on which variant to
prefer.

#2 - 03/21/2018 02:29 PM - hugopeixoto (Hugo Peixoto)
- File resolv-ipv6-to_s.patch added

shevegen (Robert A. Heiler) wrote:

Is there a standard that mandates or prefers either variant?
RFC 5952 recommends the usage of lower case letters: https://tools.ietf.org/html/rfc5952#section-4.3

The Resolv module seems to be formatting the addresses in uppercase:

Resolv::IPv6.create ("2400:8902::£f03c:91ff:fe69:a454") .to_s #=> "2400:8902::F03C:91FF:FE69:A454"
After the patch, Resolv#getaddresses now formats addresses in lowercase:

Resolv.getaddresses ("nghttp2.o0rg") #=> ["139.162.123.134", "2400:8902::£f03c:91ff:fe69:a454"]

| noticed there's an ipaddr module that handles formatting as well, so in the attached patch | am using IPAddr#new to reuse the existing code. | also
added some tests.

| am not sure if adding the dependency here is the right way to do it.

#3 - 06/20/2019 06:00 PM - jeremyevans0 (Jeremy Evans)
- File resolv-ipv6-lowercase.patch added
- Status changed from Open to Assigned

- Assignee set to akr (Akira Tanaka)

| agree that Ruby should consistently use lowercase for IPv6 addresses. However, | don't think we should introduce a dependency on ipaddr to
resolv. For one, it changes how the IPv6 addresses with noncontiguous 0 components are displayed. Attached a simpler patch that just uses %x
instead of %X in sprintf.

#4 - 07/30/2019 03:01 AM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

Applied in changeset git|1da3a31a5f0211db121e0df4ca456838a4375371.

Use lowercase letters for IPv6 addresses.

Reported by chucke (Tiago Cardoso).
Patch by jeremyevans0 (Jeremy Evans).

[Bug #14612]

Files

resolv-ipv6-to_s.patch 1.48 KB 03/21/2018 hugopeixoto (Hugo Peixoto)
resolv-ipv6-lowercase.patch 1.82 KB 06/20/2019 jeremyevans0 (Jeremy Evans)
